﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Runtime.InteropServices;

namespace WRG315Example
{
    abstract class Wrapper
    {
        private const string APIDLL_PATH = "WRG315API.dll";

        [StructLayout(LayoutKind.Sequential)]
        public struct Features
        {
            public uint feature;
        }

        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        public struct RadioInfo
        {
            public uint length;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 9)]
            public string serialNumber;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 9)]
            public string productName;
            public UInt64 minFrequency;
            public UInt64 maxFrequency;
            public Features feature;
        }

        [DllImport(APIDLL_PATH)]
        public static extern int OpenRadioDevice(int deviceNumber);

        [DllImport(APIDLL_PATH)]
        public static extern bool CloseRadioDevice(int radioHandle);

        [DllImport(APIDLL_PATH)]
        public static extern int GetRadioList(ref RadioInfo info, int bufferSize, ref int infoSize);

        [DllImport(APIDLL_PATH)]
        public static extern bool IsDeviceConnected(int radioHandle);

        [DllImport(APIDLL_PATH)]
        public static extern bool GetInfo(int radioHandle, ref RadioInfo info);

        [DllImport(APIDLL_PATH)]
        public static extern int GetFrequency(int radioHandle);

        [DllImport(APIDLL_PATH)]
        public static extern bool SetFrequency(int radioHandle, int frequency);
    }
}